<template lang="pug">
fieldset.form-group.mb-2(:disabled="disabled")
  .col-3.col-sm-12
    label {{ $tc(entity, 2) | capitalize }}
    .text-subtitle.text-gray(v-if="required") {{ $t('required') | capitalize }}
  
  .col-9.col-sm-12
    .col-12.d-flex.mt-1(v-for="(el, index) in innerValue" :key="index")
      .col-sm-12(:class="{ 'col-5': role, 'col-6': !role }")
        .form-group
          input.form-input.input-left(
            @input="() => $emit('input', emittedValue)"
            :placeholder="placeholder"
            v-model="el.name" :name="'entityName-'+index" v-validate="'required|alpha_spaces|max:30'" maxlength="30" placeholder="Name"
            :class="{ 'has-error': errors.has('entityName-'+index) }"
          )
      .col-sm-12(:class="{ 'col-3': role, 'col-5': !role }")
        .form-group
          input.form-input(
            @input="() => $emit('input', emittedValue)"
            v-model="el.affiliation" :name="'entityAffiliation-'+index" v-validate="'alpha_spaces|max:30'" maxlength="30" placeholder="Affiliation"
            :class="{ 'has-error': errors.has('entityAffiliation-'+index), 'input-right': !role, 'input-middle': role }"
          )
      .col-3.col-sm-12(v-if="role")
        select.form-select(
          v-model="el.role"
          @input="() => $emit('input', emittedValue)"
        )
          option
          option(value="Contact person") Contact person
          option(value="Data collector") Data collector
          option(value="Data curator") Data curator
          option(value="Data manager") Data manager
          option(value="Supervisor") Supervisor
          option(value="Sponsor") Sponsor
          option(value="Project manager") Project manager
          option(value="Project leader") Project leader
          option(value="Project member") Project member
          option(value="Researcher") Researcher
          option(value="Rights holder") Rights holder
          option(value="Work package leader") Work package leader
          option(value="Distributor") Distributor
          option(value="Editor") Editor
          option(value="Producer") Producer
          option(value="Graphist") Graphist
      .col-1.col-sm-12.d-flex(style="align-items:center;" :class="{ 'c-not-allowed': disabled }")
        i.material-icons.ml-2(
          tabindex="-1"
          style="font-size:0.9rem;"
          v-on:click="delEntity(index)"
          :class="{ 'c-not-allowed': disabled, 'c-hand': !disabled }"
        ) cancel

  .col-3.col-sm-12
  .col-9.col-sm-12.text-left
    button.btn.btn-sm.btn-link.mr-2.mt-1(type="button" @click="addEntity('')") {{ $t('add', { thing: $tc(entity, 1) }) | lowercase | capitalize({ onlyFirstLetter: true }) }}
    button.btn.btn-sm.btn-link.col-mr-auto.mt-1(v-if="self" type="button" @click="addEntity('')") {{ $t('add', { thing: 'self as ' + $tc(entity, 1) }) | lowercase | capitalize({ onlyFirstLetter: true }) }}
  
  .col-3.col-sm-12
  .col-9.col-sm-12.text-left
    slot
</template>

<script>
import { pick } from '~/utilities/objects'

export default {
  props: {
    entity: {
      type: String,
      default: 'contributor'
    },
    self: {
      type: Boolean,
      default: false
    },
    placeholder: {
      type: String,
      default: 'Full name'
    },
    required: Boolean,
    disabled: Boolean,
    role: Boolean,
    value: {
      type: Array,
      default: () => []
    }
  },
  data() {
    return {
      innerValue: []
    }
  },
  computed: {
    valid() {
      return true
    },
    emittedValue() {
      const fields = ['name', 'orcid', 'email', 'affiliation', 'role']
      return this.innerValue
        .filter(v => v.name !== '')
        .map(v => pick(v, fields))
    }
  },
  mounted() {
    this.$nextTick(function() {
      // Code that will run only after the
      // entire view has been rendered
      this.innerValue =
        this.value === null || this.value === [] || this.value === undefined
          ? [
              {
                name,
                affiliation: '',
                role: ''
              }
            ]
          : typeof this.value === 'string'
          ? JSON.parse(this.value)
          : this.value
      this.$emit('input', this.emittedValue)
    })
  },
  methods: {
    addEntity(name) {
      this.innerValue.push({
        name,
        affiliation: '',
        role: ''
      })
    },
    delEntity(index) {
      if (!this.disabled) this.innerValue.splice(index, 1)
      this.$emit('input', this.emittedValue)
    }
  },
  $_veeValidate: {
    validator: 'new'
  }
}
</script>

<style scoped>
.input-middle,
.input-left {
  border-top-right-radius: 0;
  border-bottom-right-radius: 0;
}
.input-middle,
.input-right {
  border-top-left-radius: 0;
  border-bottom-left-radius: 0;
}
</style>
